
#include <PubSubClient.h>
#include <ESP8266WiFi.h>
#include <OneWire.h>
#include <EEPROM.h>

int val0;
int val1;
int val2;
int val3;
int val4;
int val5;
int val6;
int val7;
int val8;

int r1=16;
int r2=5;
int r3=4;
int r4=0;// GPIO5 or for NodeMCU you can directly write D1
int r5=14;
int r6=12;
int r7=13;
int r8=15;

String SensorT = "/temp/28ff4f3c8c163e9"; // sensor wire for thermostat uses 2-4 digital pins 5-8
String SensorT1 = "/temp/28ff5d370164db"; // simple on off of relay if oy want * realy controls leave  SensorT empty and fill in T1 - T8 with your IDs
String SensorT2 = "/temp/28ffb7da8b1634b";
String SensorT3 = "";
String SensorT4 = "";
String SensorT5 = "";// past this point you have to remove SensorT data  refference and us "" as these overlap with digital pin use 
String SensorT6 = "";
String SensorT7 = "";
String SensorT8 = ""; //disable Serial debuging  if usung digital pin 7-8

int eco = 0;
int cool =0;
int heat =0; 
int fan =0;

float preset;
float preset1;
float preset2;
float preset3;
float preset4;
float preset5;
float preset6;
float preset7;
float preset8;

float CurrentT; 
float CurrentT1;
float CurrentT2;
float CurrentT3;
float CurrentT4;
float CurrentT5;
float CurrentT6;
float CurrentT7;
float CurrentT8;


long lastMsg1 = 0;
long lastMsg = 0;
char msg[50];
int value = 0;
int cntID=0;

//Basic Wifi and MQTT-Server Information
const char* ssid = "IOT";
const char* password = "";
char* server = "192.168.168.150";
String clientName;
//DS18B20 on GPIO2
OneWire  ds(2);

WiFiClient wifiClient;
PubSubClient client(server, 1883, wifiClient);

void callback(char* topic, byte* payload, unsigned int length) {
  
String input1 = "/switch/SW1";  /// edit to denote what switch topic it is asscosiated with

if (input1 == topic){
 String inString = "";
  //scan++;
  for (int i=0;i<length;i++) {
     inString +=  ((char)payload[i]);
  }
  Serial.print("Recieved("); Serial.print(inString); Serial.println(")");
  //int presetp = inString.toInt();
  if (inString=="1") {   ///relay control thermostat interface
    preset = (preset+1);
    Serial.print("up "); Serial.print( preset); Serial.print( " ");
    String raw_CMD ;
    raw_CMD= preset;
    Serial.println(raw_CMD);
    if (client.connected()){
    client.publish("/temp/Tset", (char*) raw_CMD.c_str()); 
    }
  }
  if (inString=="0") {
    preset = (preset-1);
    Serial.print("down "); Serial.print( preset); Serial.print( " ");
    String raw_CMD ;
    raw_CMD= preset;
     Serial.println(raw_CMD);
    if (client.connected()){
    client.publish("/temp/Tset", (char*) raw_CMD.c_str()); 
    }
  }
if (inString=="1e") { //eco setting
    eco = (eco+1);
    Serial.print("e-on "); Serial.print( eco); Serial.print( " ");
    String raw_CMD ;
    if (eco >1) eco =1;
    raw_CMD= eco;
    Serial.println(raw_CMD);
    if (client.connected()){
    client.publish("/temp/Teco", (char*) raw_CMD.c_str()); 
    }
  }
  if (inString=="0e") {
    eco = (eco-1);
    Serial.print("e-off "); Serial.print( eco); Serial.print( " ");
    String raw_CMD ;
    if (eco <0) eco =0;
    raw_CMD= eco;
     Serial.println(raw_CMD);
    if (client.connected()){
    client.publish("/temp/Teco", (char*) raw_CMD.c_str()); 
    }
  }
if (inString=="1c") {  //cooling
    cool = (cool+1);
    Serial.print("c-on "); Serial.print( cool); Serial.print( " ");
    String raw_CMD ;
    if (cool >1) cool =1;
    raw_CMD= cool;
    Serial.println(raw_CMD);
    if (client.connected()){
    client.publish("/temp/Tcool", (char*) raw_CMD.c_str()); 
    }
  }
  if (inString=="0c") {
    cool = (cool-1);
    Serial.print("c-off "); Serial.print( cool); Serial.print( " ");
    String raw_CMD ;
    if (cool <0) cool =0;
    raw_CMD= cool;
     Serial.println(raw_CMD);
    if (client.connected()){
    client.publish("/temp/Tcool", (char*) raw_CMD.c_str()); 
    }
  }
  if (inString=="1f") { //fan 
    fan = (fan+1);
    Serial.print("f-on "); Serial.print(fan); Serial.print( " ");
    String raw_CMD ;
    if (fan >1) fan =1;
    raw_CMD= fan;
    Serial.println(raw_CMD);
    if (client.connected()){
    client.publish("/temp/Tfan", (char*) raw_CMD.c_str()); 
    }
  }
  if (inString=="0f") {
    fan = (fan-1);
    Serial.print("f-off "); Serial.print(fan); Serial.print( " ");
    String raw_CMD ;
    if (fan <0) fan =0;
    raw_CMD= fan;
     Serial.println(raw_CMD);
    if (client.connected()){
    client.publish("/temp/Tfan", (char*) raw_CMD.c_str()); 
    }
  }
  if (inString=="1h") { //heating
    heat = (heat+1);
    Serial.print("h-on "); Serial.print( heat); Serial.print( " ");
    String raw_CMD ;
    if (heat >2) heat =0;
    raw_CMD= heat;
    Serial.println(raw_CMD);
    if (client.connected()){
    client.publish("/temp/Theat", (char*) raw_CMD.c_str()); 
    }
  }
  if (inString=="0h") {
    heat = (heat-1);
    Serial.print("h-off "); Serial.print( heat); Serial.print( " ");
    String raw_CMD ;
    if (heat <0) heat =2;
    raw_CMD= heat;
     Serial.println(raw_CMD);
    if (client.connected()){
    client.publish("/temp/Theat", (char*) raw_CMD.c_str()); 
    }
  }
if (inString=="11") {   //relay 1
    preset1 = (preset1+1);
    Serial.print("up "); Serial.print( preset1); Serial.print( " ");
    String raw_CMD ;
    raw_CMD= preset1;
    Serial.println(raw_CMD);
    if (client.connected()){
    client.publish("/temp/Tset1", (char*) raw_CMD.c_str()); 
    }
  }
  if (inString=="01") {
    preset1 = (preset1-1);
    Serial.print("down "); Serial.print( preset1); Serial.print( " ");
    String raw_CMD ;
    raw_CMD= preset1;
     Serial.println(raw_CMD);
    if (client.connected()){
    client.publish("/temp/Tset1", (char*) raw_CMD.c_str()); 
    }
  }
if (inString=="12") { //relay2
    preset2 = (preset2+1);
    Serial.print("up "); Serial.print( preset2); Serial.print( " ");
    String raw_CMD ;
    raw_CMD= preset2;
    Serial.println(raw_CMD);
    if (client.connected()){
    client.publish("/temp/Tset2", (char*) raw_CMD.c_str()); 
    }
  }
  if (inString=="02") {
    preset2 = (preset2-1);
    Serial.print("down "); Serial.print( preset2); Serial.print( " ");
    String raw_CMD ;
    raw_CMD= preset2;
     Serial.println(raw_CMD);
    if (client.connected()){
    client.publish("/temp/Tset2", (char*) raw_CMD.c_str()); 
    }
  }
if (inString=="13") {  //relay3
    preset3 = (preset3+1);
    Serial.print("up "); Serial.print( preset3); Serial.print( " ");
    String raw_CMD ;
    raw_CMD= preset3;
    Serial.println(raw_CMD);
    if (client.connected()){
    client.publish("/temp/Tset3", (char*) raw_CMD.c_str()); 
    }
  }
  if (inString=="03") {
    preset3 = (preset3-1);
    Serial.print("down "); Serial.print( preset3); Serial.print( " ");
    String raw_CMD ;
    raw_CMD= preset3;
     Serial.println(raw_CMD);
    if (client.connected()){
    client.publish("/temp/Tset3", (char*) raw_CMD.c_str()); 
    }
  }
  if (inString=="14") { //relay4
    preset4 = (preset4+1);
    Serial.print("up "); Serial.print( preset4); Serial.print( " ");
    String raw_CMD ;
    raw_CMD= preset4;
    Serial.println(raw_CMD);
    if (client.connected()){
    client.publish("/temp/Tset4", (char*) raw_CMD.c_str()); 
    }
  }
  if (inString=="04") {
    preset4 = (preset4-1);
    Serial.print("down "); Serial.print( preset4); Serial.print( " ");
    String raw_CMD ;
    raw_CMD= preset4;
     Serial.println(raw_CMD);
    if (client.connected()){
    client.publish("/temp/Tset4", (char*) raw_CMD.c_str()); 
    }
  }
if (inString=="15") { //relay5
    preset5 = (preset5+1);
    Serial.print("up "); Serial.print( preset5); Serial.print( " ");
    String raw_CMD ;
    raw_CMD= preset5;
    Serial.println(raw_CMD);
    if (client.connected()){
    client.publish("/temp/Tset5", (char*) raw_CMD.c_str()); 
    }
  }
  if (inString=="05") {
    preset5 = (preset5-1);
    Serial.print("down "); Serial.print( preset5); Serial.print( " ");
    String raw_CMD ;
    raw_CMD= preset5;
     Serial.println(raw_CMD);
    if (client.connected()){
    client.publish("/temp/Tset5", (char*) raw_CMD.c_str()); 
    }
  }
if (inString=="16") {      //relay6
    preset6 = (preset6+1);
    Serial.print("up "); Serial.print( preset6); Serial.print( " ");
    String raw_CMD ;
    raw_CMD= preset6;
    Serial.println(raw_CMD);
    if (client.connected()){
    client.publish("/temp/Tset6", (char*) raw_CMD.c_str()); 
    }
  }
  if (inString=="06") {
    preset6 = (preset6-1);
    Serial.print("down "); Serial.print( preset6); Serial.print( " ");
    String raw_CMD ;
    raw_CMD= preset6;
     Serial.println(raw_CMD);
    if (client.connected()){
    client.publish("/temp/Tset6", (char*) raw_CMD.c_str()); 
    }
  }
  if (inString=="17") {   //relay7
    preset7 = (preset7+1);
    Serial.print("up "); Serial.print( preset7); Serial.print( " ");
    String raw_CMD ;
    raw_CMD= preset7;
    Serial.println(raw_CMD);
    if (client.connected()){
    client.publish("/temp/Tset7", (char*) raw_CMD.c_str()); 
    }
  }
  if (inString=="07") {
    preset7 = (preset7-1);
    Serial.print("down "); Serial.print( preset7); Serial.print( " ");
    String raw_CMD ;
    raw_CMD= preset7;
     Serial.println(raw_CMD);
    if (client.connected()){
    client.publish("/temp/Tset7", (char*) raw_CMD.c_str()); 
    }
  }
  if (inString=="18") {     //relay8
    preset8 = (preset8+1);
    Serial.print("up "); Serial.print( preset8); Serial.print( " ");
    String raw_CMD ;
    raw_CMD= preset8;
    Serial.println(raw_CMD);
    if (client.connected()){
    client.publish("/temp/Tset8", (char*) raw_CMD.c_str()); 
    }
  }
  if (inString=="08") {
    preset8 = (preset8-1);
    Serial.print("down "); Serial.print( preset8); Serial.print( " ");
    String raw_CMD ;
    raw_CMD= preset8;
     Serial.println(raw_CMD);
    if (client.connected()){
    client.publish("/temp/Tset8", (char*) raw_CMD.c_str()); 
    }
  }
  }
}


String macToStr(const uint8_t* mac)
{
  String result;
  for (int i = 0; i < 6; ++i) {
    result += String(mac[i], 16);
    if (i < 5)
      result += ':';
  }
  return result;
}

void setup() {
  pinMode(BUILTIN_LED, OUTPUT);     // Initialize the BUILTIN_LED pin as an output
  //Serial.begin(115200);
  EEPROM.begin(512);
  delay(10);
  pinMode(r1, OUTPUT);
  pinMode(r2, OUTPUT);
  pinMode(r3, OUTPUT);
  pinMode(r4, OUTPUT);
  pinMode(r5, OUTPUT);
  pinMode(r6, OUTPUT);
  pinMode(r7, OUTPUT);
  pinMode(r8, OUTPUT);
   digitalWrite(r1, HIGH);
   digitalWrite(r2, HIGH);
   digitalWrite(r3, HIGH);
   digitalWrite(r4, HIGH);
   digitalWrite(r5, HIGH);
   digitalWrite(r6, HIGH);
   digitalWrite(r7, HIGH);
   digitalWrite(r8, HIGH);
  
  int firsttime = EEPROM.read(9);
  if (firsttime==1){ Serial.println(" EEprom Written Already");} else {
    int tmp = 18; 
    EEPROM.write(0,tmp);
    EEPROM.write(1, tmp);
    EEPROM.write(2, tmp);
    EEPROM.write(3, tmp);
    EEPROM.write(4, tmp);
    EEPROM.write(5,tmp);
    EEPROM.write(6,tmp);
    EEPROM.write(7,tmp);
    EEPROM.write(8,tmp);
    EEPROM.write(9,1);
    Serial.println(" Setting primary  tempertures to eeprom");
    EEPROM.commit();
    delay(50);
  }
  
 Serial.println("_________________________________");  
int val0 = EEPROM.read(0);Serial.println(val0);
int val1 = EEPROM.read(1);Serial.println(val1);
int val2 = EEPROM.read(2);Serial.println(val2);
int val3 = EEPROM.read(3);Serial.println(val3);
int val4 = EEPROM.read(4);Serial.println(val4);
int val5 = EEPROM.read(5);Serial.println(val5);
int val6 = EEPROM.read(6);Serial.println(val6);
int val7 = EEPROM.read(7);Serial.println(val7);
int val8 = EEPROM.read(8);Serial.println(val8);
Serial.println("_________________________________");
preset = val0;
preset1 = val1;
preset2 = val2;
preset3 = val3;
preset4 = val4;
preset5 = val5;
preset6 = val6;
preset7 = val7;
preset8 = val8;
 
  setup_wifi();
  client.setCallback(callback);
}

void setup_wifi(){
  
  Serial.println();
  Serial.println();
  Serial.print("Connecting to ");
  Serial.println(ssid);
  
  WiFi.begin(ssid, password);
  WiFi.mode(WIFI_STA);
  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
  }
  Serial.println("");
  Serial.println("WiFi connected");  
  Serial.println("IP address: ");
  Serial.println(WiFi.localIP());

  // Generate client name based on MAC address and last 8 bits of microsecond counter
  
  clientName += "esp8266-";
  uint8_t mac[6];
  WiFi.macAddress(mac);
  clientName += macToStr(mac);
  clientName += "-";
  clientName += String(micros() & 0xff, 16);

  Serial.print("Connecting to ");
  Serial.print(server);
  Serial.print(" as ");
  Serial.println(clientName);
  
  //MQTT_Connect();
  }
  
  void MQTT_Connect(){
     // Loop until we're reconnected
  while (!client.connected()) {
    Serial.print("Attempting MQTT connection...");
    if (client.connect((char*) clientName.c_str())) {
    Serial.println("Connected to MQTT broker");
   client.subscribe("/switch/SW1");
   delay(500);
   String raw_CMD ;
    raw_CMD= preset;
    Serial.println(raw_CMD);
client.publish("/temp/Tset", (char*) raw_CMD.c_str());
   
   //client.subscribe("/temp/28ff4f3c8c163e9");
  }
  else {
    Serial.println("MQTT connect failed");
    Serial.println("Will reset and try again...");
    delay(5000);
  }
 // client.setCallback(callback);
    }
  }
//timer.setInterval(9000L, setup_wifi);

void loop() {
  if(WiFi.status() != WL_CONNECTED){setup_wifi();}
  if (!client.connected()) {
    MQTT_Connect();
 }
 client.loop();
  //Sensor();
  long now = millis();
  if (now - lastMsg > 2000) {
    lastMsg = now;
    
Sensor();

if (SensorT !=""){  Relay_control();}
if (SensorT1 !=""){Relay_control1();}
if (SensorT2 !=""){Relay_control2();}
if (SensorT3 !=""){Relay_control3();}
if (SensorT4 !=""){Relay_control4();}
if (SensorT5 !=""){Relay_control5();}
if (SensorT6 !=""){Relay_control6();}
if (SensorT7 !=""){Relay_control7();}
if (SensorT8 !=""){Relay_control8();}

  }
long now1 = millis();
  if (now1 - lastMsg1 > 60000) {
    lastMsg1 = now1;
val0=preset; 
val1=preset1; 
val2=preset2; 
val3=preset3; 
val4=preset4; 
val5=preset5; 
val6=preset6; 
val7=preset7; 
val8=preset8; 

int val0a;
int val1a;
int val2a;
int val3a;
int val4a;
int val5a;
int val6a;
int val7a;
int val8a;

val0a = EEPROM.read(0); Serial.println(val0a);
val1a = EEPROM.read(1);Serial.println(val1a);
val2a = EEPROM.read(2) ;Serial.println(val2a);
val3a = EEPROM.read(3);Serial.println(val3a);
val4a = EEPROM.read(4);Serial.println(val4a);
val5a = EEPROM.read(5);Serial.println(val5a);
val6a = EEPROM.read(6);Serial.println(val6a);
val7a = EEPROM.read(7);Serial.println(val7a);
val8a = EEPROM.read(8);Serial.println(val8a);
 Serial.println("_________________________________"); 
   
 if (val0a == val0){Serial.println("unchanged");}else{EEPROM.write(0, val0);Serial.println("wrote eeprom 0 ");Serial.println(val0);}
 if (val1a == val1){Serial.println("unchanged");}else{EEPROM.write(1, val1);Serial.println("wrote eeprom 1 ");Serial.println(val1); }
 if (val2a == val2){Serial.println("unchanged");}else{ EEPROM.write(2, val2);Serial.println("wrote eeprom 2 ");Serial.println(val2); }
 if (val3a == val3){Serial.println("unchanged");}else{ EEPROM.write(3, val3);Serial.println("wrote eeprom 3 ");Serial.println(val3);} 
 if (val4a == val4){Serial.println("unchanged");}else{ EEPROM.write(4, val4);Serial.println("wrote eeprom 4 ");Serial.println(val4); }
 if (val5a == val5){Serial.println("unchanged");}else{ EEPROM.write(5, val5);Serial.println("wrote eeprom 5 "); Serial.println(val5);}
 if (val6a == val6){Serial.println("unchanged");}else{ EEPROM.write(6, val6);Serial.println("wrote eeprom 6 ");Serial.println(val6); }
 if (val7a == val7){Serial.println("unchanged");}else{ EEPROM.write(7, val7);Serial.println("wrote eeprom 7 ");Serial.println(val7);} 
 if (val8a == val8){Serial.println("unchanged");}else{  EEPROM.write(8, val8); Serial.println("wrote eeprom 8 ");Serial.println(val8); } 
   EEPROM.commit();
 Serial.println("_________________________________");
  
  } 
}

void Relay_control(){
  if ((preset) < (CurrentT-0.75)) {  // 0.75 is the thermostat sensitivity .75 c above and below prest for a variation of 1.5 c
    Serial.println("relay1 off ");
    
   
     if (heat ==1){ digitalWrite(r8, HIGH);digitalWrite(r6, HIGH);}  
     if (heat ==2){ digitalWrite(r7, HIGH);digitalWrite(r6, HIGH);}
     
                    }
  
  if ((preset) > (CurrentT+0.75)) {

    
  Serial.println("relay1 on");
  if (heat ==1){ digitalWrite(r8, LOW); digitalWrite(r6, LOW);}
   if (heat ==2){ digitalWrite(r7, LOW); digitalWrite(r6, LOW);}
  }
}
void Relay_control1(){
  if ((preset1) < (CurrentT1-0.75)){
    Serial.println("relay off");
     digitalWrite(r1, HIGH);
  }
  if ((preset1) > (CurrentT1+0.75)) {
    Serial.println("relay on");
     digitalWrite(r1, LOW);
  }
}
void Relay_control2(){
  if ((preset2) < (CurrentT2-0.75)) {Serial.println("relay off"); digitalWrite(r2, HIGH);}
  if ((preset2) > (CurrentT2+0.75)) {Serial.println("relay on"); digitalWrite(r2, LOW);}
}
void Relay_control3(){
  if ((preset3) < (CurrentT3-0.75)) {Serial.println("relay off"); digitalWrite(r3, HIGH);}
  if ((preset3) > (CurrentT3+0.75)) {Serial.println("relay on"); digitalWrite(r3, LOW);}
}
void Relay_control4(){
  if ((preset4) < (CurrentT4-0.75)) {Serial.println("relay off"); digitalWrite(r4, HIGH);}
  if ((preset4) > (CurrentT4+0.75)) {Serial.println("relay on"); digitalWrite(r4, LOW);}
}
void Relay_control5(){
  if ((preset5) < (CurrentT5-0.75)) {Serial.println("relay off"); digitalWrite(r5, HIGH);}
  if ((preset5) > (CurrentT5+0.75)) {Serial.println("relay on"); digitalWrite(r5, LOW);}
}
void Relay_control6(){
  if ((preset6) < (CurrentT6-0.75)) {Serial.println("relay off"); digitalWrite(r6, HIGH);}
  if ((preset6) > (CurrentT6+0.75)) {Serial.println("relay on"); digitalWrite(r6, LOW);}
}
void Relay_control7(){
  if ((preset7) < (CurrentT7-0.75)) {Serial.println("relay off"); digitalWrite(r7, HIGH);}
  if ((preset7) > (CurrentT7+0.75)) {Serial.println("relay on"); digitalWrite(r7, LOW);}
}
void Relay_control8(){
  if ((preset8) < (CurrentT8-0.75)) {Serial.println("relay off"); digitalWrite(r8, HIGH);}
  if ((preset8) > (CurrentT8+0.75)) {Serial.println("relay on"); digitalWrite(r8, LOW);}
}




 void Sensor() {
  byte i;
  byte present = 0;
  byte type_s;
  byte data[12];
  byte addr[8];
  

//Loop through all DS1820

while(ds.search(addr))
{ 
  //Serial.print("ROM =");

//Topic is built from a static String plus the ID of the DS18B20
  String romcode = "/temp/";
  String romID = "/ID/";
  for( i = 0; i < 8; i++) {
   // Serial.write(' ');
   // Serial.print(addr[i], HEX);
    
    romcode = romcode + String(addr[i], HEX);
  }

  if (OneWire::crc8(addr, 7) != addr[7]) {
      Serial.println("CRC is not valid!");
      return;
  }
 // Serial.println();
 
// the first ROM byte indicates which chip
  switch (addr[0]) {
    case 0x10:
     // Serial.println("  Chip = DS18S20");  // or old DS1820
      type_s = 1;
      break;
    case 0x28:
      //Serial.println("  Chip = DS18B20");
      type_s = 0;
      break;
    case 0x22:
     // Serial.println("  Chip = DS1822");
      type_s = 0;
      break;
    default:
     // Serial.println("Device is not a DS18x20 family device.");
      return;
  } 

  ds.reset();
  ds.select(addr);
  ds.write(0x44, 1);        // start conversion, with parasite power on at the end
  
  delay(1000);     // maybe 750ms is enough, maybe not
  // we might do a ds.depower() here, but the reset will take care of it.
  
  present = ds.reset();
  ds.select(addr);    
  ds.write(0xBE);         // Read Scratchpad

  //Serial.print("  Data = ");
  //Serial.print(present, HEX);
  //Serial.print(" ");
  for ( i = 0; i < 9; i++) {           // we need 9 bytes
    data[i] = ds.read();
  //  Serial.print(data[i], HEX);
   // Serial.print(" ");
  }
  //Serial.print(" CRC=");
  //Serial.print(OneWire::crc8(data, 8), HEX);
  //Serial.println();

  int16_t raw = (data[1] << 8) | data[0];
  if (type_s) {
    raw = raw << 3; // 9 bit resolution default
    if (data[7] == 0x10) {
      // "count remain" gives full 12 bit resolution
      raw = (raw & 0xFFF0) + 12 - data[6];
    }
  } else {
    byte cfg = (data[4] & 0x60);
    // at lower res, the low bits are undefined, so let's zero them
    if (cfg == 0x00) raw = raw & ~7;  // 9 bit resolution, 93.75 ms
    else if (cfg == 0x20) raw = raw & ~3; // 10 bit res, 187.5 ms
    else if (cfg == 0x40) raw = raw & ~1; // 11 bit res, 375 ms
    //// default is 12 bit resolution, 750 ms conversion time
  }

//convert RAW Temperature to String
String raw_temp = String(raw, DEC);
float tempc=(raw_temp.toFloat());
tempc=(tempc/16);
raw_temp=tempc;

  if (client.connected()){
    //Serial.print("Sending payload: ");
   // Serial.println(raw_temp);
  }
  if (20 > cntID){
    if (client.publish((char*) romID.c_str(), (char*) romcode.c_str())) {
      //Serial.println((char*) romID.c_str());
      //Serial.println("Publish ok");
      cntID =(cntID +1 );
       //Serial.println(cntID);
    }
    
  }
  
if (SensorT == ((char*) romcode.c_str() )) {CurrentT =raw_temp.toFloat(); Serial.println(CurrentT);}
if (SensorT1 == ((char*) romcode.c_str()) ) {CurrentT1 =raw_temp.toFloat();Serial.print("CurrentT1  ");Serial.println(CurrentT1);}
if (SensorT2 == (char*) romcode.c_str() ) {CurrentT2 =raw_temp.toFloat();Serial.println(CurrentT2);}
if (SensorT3 == (char*) romcode.c_str() ) {CurrentT3 =raw_temp.toFloat();Serial.println(CurrentT3);}
if (SensorT4 == (char*) romcode.c_str() ) {CurrentT4 =raw_temp.toFloat();Serial.println(CurrentT4);}
if (SensorT5 == (char*) romcode.c_str() ) {CurrentT5 =raw_temp.toFloat();Serial.println(CurrentT5);}
if (SensorT6 == (char*) romcode.c_str() ){ CurrentT6 =raw_temp.toFloat();Serial.println(CurrentT6);}
if (SensorT7 == (char*) romcode.c_str() ) {CurrentT7 =raw_temp.toFloat();Serial.println(CurrentT7);}
if (SensorT8 == (char*) romcode.c_str() ) {CurrentT8 =raw_temp.toFloat(); Serial.println(CurrentT8);} 
  
    if (client.publish((char*) romcode.c_str(), (char*) raw_temp.c_str())) {
      Serial.println((char*) romcode.c_str());
      Serial.println("Publish ok");
    }
    else {
      Serial.println("Publish failed");
    }

  //delay(5000);
}
//End of the OneWire-Devices, reset Loop
//Serial.println("End of Onewire Bus");
ds.reset_search();
return;
}


